#include "dtga.h"
#include "gramschm.h"


void GramSchmidt(int *V1,int *V2,int *V3,int *W)
{
    int  w1[3],w2[3],w3[3];
    long sw1,sw2,dot;

     /* set w1 = v1 */


     
     w1[0] = V1[0];
     w1[1] = V1[1];
     w1[2] = V1[2];

     /* find w2 */


     dot = ((long) V2[0]*w1[0] + (long) V2[1]*w1[1] + (long) V2[2]*w1[2]);
     dot = (dot + 2) >> 2;
     sw1 = ((long) w1[0]*w1[0] + (long) w1[1]*w1[1] + (long) w1[2]*w1[2]);
     sw1 = (sw1 + 2) >> 2;

     w2[0] = V2[0] - dot*w1[0]/sw1;
     w2[1] = V2[1] - dot*w1[1]/sw1;
     w2[2] = V2[2] - dot*w1[2]/sw1;


     /* find w3 */

     dot = ((long) V3[0]*w1[0] + (long) V3[1]*w1[1] + (long) V3[2]*w1[2]);
     dot = (dot +2) >> 2;

     w3[0] = V3[0] - dot*w1[0]/sw1;
     w3[1] = V3[1] - dot*w1[1]/sw1;
     w3[2] = V3[2] - dot*w1[2]/sw1;

     dot = ((long) V3[0]*w2[0] + (long) V3[1]*w2[1] + (long) V3[2]*w2[2]);
     dot = (dot +2) >> 2;

     sw2 = ((long) w2[0]*w2[0] + (long) w2[1]*w2[1] + (long) w2[2]*w2[2]);
     sw2 = (sw2 + 2) >> 2;

     w3[0] -=  dot*w2[0]/sw2;
     w3[1] -=  dot*w2[1]/sw2;
     w3[2] -=  dot*w2[2]/sw2;

     W[0] = w3[0];
     W[1] = w3[1];
     W[2] = w3[2];
}







